- Qt 6.5
- Qt GUI
- C++ Classes
- QIconEnginePlugin
- Qt 6.5.0 Reference Documentation

# QIconEnginePlugin Class

The QIconEnginePlugin class provides an abstract base for custom QIconEngine plugins. More...

Header: | #include <QIconEnginePlugin>
CMake: | find_package(Qt6 REQUIRED COMPONENTS Gui) target_link_libraries(mytarget PRIVATE Qt6::Gui)
qmake: | QT += gui
Inherits: | QObject

- List of all members, including inherited members
- QIconEnginePlugin is part of Plugin Classes.

## Public Functions

| QIconEnginePlugin(QObject *parent = nullptr)
virtual | ~QIconEnginePlugin()
virtual QIconEngine * | create(const QString &filename = QString()) = 0

## Detailed Description

The icon engine plugin is a simple plugin interface that makes it easy to create custom icon engines that can be loaded dynamically into applications through QIcon. QIcon uses the file or resource name's suffix to determine what icon engine to use.

Writing a icon engine plugin is achieved by subclassing this base class, reimplementing the pure virtual function create(), and exporting the class with the Q_PLUGIN_METADATA() macro.

The json metadata should contain a list of icon engine keys that this plugin supports. The keys correspond to the suffix of the file or resource name used when the plugin was created. Keys are case insensitive.

     { "Keys": [ "myiconengine" ] }

See also How to Create Qt Plugins.

## Member Function Documentation

### QIconEnginePlugin::QIconEnginePlugin(QObject *parent = nullptr)

Constructs a icon engine plugin with the given parent. This is invoked automatically by the plugin loader.

### `[virtual]` QIconEnginePlugin::~QIconEnginePlugin()

Destroys the icon engine plugin.

You never have to call this explicitly. Qt destroys a plugin automatically when it is no longer used.

### `[pure virtual]` QIconEngine *QIconEnginePlugin::create(const QString &filename = QString())

Creates and returns a QIconEngine object for the icon with the given filename.